import React, { useState, useEffect } from "react";
import "./Ending.css";
import * as Tone from "tone";
import Pics from './Images/munch.jpg';

function Circle() {
    const [size, setSize] = useState(400);

    useEffect(() => {
        const analyser = new Tone.Analyser("fft", 1024);
        const mic = new Tone.UserMedia();
        mic.open();
        mic.connect(analyser);
        analyser.connect(Tone.Destination);

        const loop = new Tone.Loop((time) => {
            const data = analyser.getValue();
            console.log(data);
            const sum = data.reduce((acc, val) => acc + val);
            const avg = sum / data.length;
            //const newSize = Math.max(10, 50 - avg * 1000);
            //const newSize = Math.max(10, Math.min(100, size + avg * 50));
            //const newSize = Math.max(10, Math.min(100, size + avg * 2000));
            const newSize = Math.max(1, 100 - avg * 1);


            const limitedSize = Math.min(newSize, 400); // limit the size to 400 pixels
            setSize(limitedSize);

            /*const newSize = Math.max(10, 50 - avg * 50);
            setSize(newSize);*/
        }, "16n");
        loop.start();
        loop.start(0);

        Tone.Transport.start();

        const handleClick = () => {
            Tone.start();
            document.removeEventListener("click", handleClick);
        };
        document.addEventListener("click", handleClick);

        return () => {
            mic.close();
            loop.stop();
            analyser.dispose();
        };
    }, []);

    return <div className="circle" style={{ width: size, height: size }}></div>;
}


const Ending = (props) => {
    return (
        <section id="ending">
            <div className="container">
                <div className="heading-wrapper">
                    <div className="heading">
                        <p className="title">Get ready to scream</p>
                        <img src={Pics}
                            alt="Image description"
                            id="my-image" />
                    </div>
                </div>
                <Circle />
            </div>
        </section>
    );
};
export default Ending;

